#!/usr/bin/perl

# cbradjusttime.pl v1.0 by k8gu (ethan@k8gu.com)
# 30 November 2010
# licensed under GPL, see LICENSE for details

use Switch;
use POSIX;

$chopmobilecounty = 0;
$chopmobile = 0;
$callcolumn = 6;

for ($i = 0; $i < (0+@ARGV); $i++) {
    switch (@ARGV[$i]) {
	case "-M" { $chopmobile = 1 }
	case "+M" { $chopmobile = 0 }
	case "-C" { $chopmobilecounty = 1 }
	case "+C" { $chopmobilecounty = 0 }
	case /(\d{1,2})/ { $callcolumn = @ARGV[$i] }
    }
}

while ($logline = <STDIN>) {
    chomp $logline;
    $band = "";
    $mode = "";
    $call = "";
    $rsts = "";
    $rstr = "";
    $date = "";
    $time = "";

    @fields = split/\s+/,$logline;

    if (@fields[0] =~ m/QSO/s) {
	
	$freq = @fields[1];
	$freqdn = $freq;
	if ((($freq < 28000) & ($freq > 2000)) | ($freq > 50000)) {
	    $freqdn = floor($freq/500)*500;
	}
	if ($freq < 2000) {
	    $freqdn = 1800;
	}
	if (($freq >= 28000) & ($freq < 30000)) {
	    $freqdn = 28000;
	}


	if ($freqdn == "1800") { 
	    $band = "160M"; 
	}
	if ($freqdn == "3500") { 
	    $band = "80M"; 
	}
	if ($freqdn == "7000") { 
	    $band = "40M"; 
	}
	if ($freqdn == "14000") { 
	    $band = "20M"; 
	}
	if ($freqdn == "21000") { 
	    $band = "15M"; 
	}
	if ($freqdn == "28000") { 
	    $band = "10M"; 
	}

	$mode = @fields[2];
	if ($mode eq "PH") {
	    $mode = "SSB";
	}

	$date = @fields[3];
	$date =~ s/-//gs;
	
	$time = @fields[4];

#	$mycall = @fields[5];

	$call = @fields[$callcolumn];

	if (($chopmobilecounty == 1) & ($call =~ m/([AKNW][A-Z]{0,1}[0-9][A-Z]{1,3}\/{0,1}M{0,1})\/[A-Z]{3,4}/s)) {
	    $call = $1;
	}
	if ($chopmobile == 1) {
	    $call =~ s/\/M//gs;
	}

	$rstr = "59";
	$rsts = "59";
	if ($mode eq "CW") {
	    $rstr = $rstr . "9";
	    $rsts = $rsts . "9";
	}

	$adif = sprintf("<call:%d>%s<qso_date:%d>%s<time_on:%d>%s<band:%d>%s<mode:%d>%s<rst_rcvd:%d>%s<rst_sent:%d>%s<eor>",length($call),$call,length($date),$date,length($time),$time,length($band),$band,length($mode),$mode,length($rstr),$rstr,length($rsts),$rsts);
	if ((length($call) > 0) & (length($date) > 0)) {
	    print "$adif\n";
	}
    }

}
