#!/usr/bin/perl

# cbradjusttime.pl v1.0 by k8gu (ethan@k8gu.com)
# 30 November 2010
# licensed under GPL, see LICENSE for details

use Switch;

$chopmobilecounty = 0;
$chopmobile = 0;

for ($i = 0; $i < (0+@ARGV); $i++) {
    switch (@ARGV[$i]) {
	case "-M" { $chopmobile = 1 }
	case "+M" { $chopmobile = 0 }
	case "-C" { $chopmobilecounty = 1 }
	case "+C" { $chopmobilecounty = 0 }
    }
}

while ($logline = <STDIN>) {
    chomp $logline;
    $band = "";
    $mode = "";
    $call = "";
    $rsts = "";
    $rstr = "";
    $date = "";
    $time = "";

    if ($logline =~ m/\s+(\d{1,4})([A-Z]{2,3})\s+/s) {
	if ($2 eq "PH") {
	    $mode = "SSB";
	} else {
	    $mode = $2;
	}
	$band = $1;
	$band = $band . "M";
    }
    if ($logline =~ m/\s+(\d{1,2}):(\d{2})\s+/s) {
	$time = $1 . $2;
    }
    if ($logline =~ m/([0-3]{0,1}[0-9])-([A-Za-z]{3})-([0-9]{2})/s) {
	if ($3 < 90) {
	    $year = $3+2000;
	} else {
	    $year = $3+1900;
	}
	switch (lc($2)) {
	    case "jan" { $month = 1 }
	    case "feb" { $month = 2 }
	    case "mar" { $month = 3 }
	    case "apr" { $month = 4 }
	    case "may" { $month = 5 }
	    case "jun" { $month = 6 }
	    case "jul" { $month = 7 }
	    case "aug" { $month = 8 }
	    case "sep" { $month = 9 }
	    case "oct" { $month = 10 }
	    case "nov" { $month = 11 }
	    case "dec" { $month = 12 }
	    else { $month = 0 }
	}
        $date = sprintf("%04d%02d%02d",$year,$month,$1);
    }

    if ($logline =~ m/\s+([A-Z]{0,3}[0-9]{0,3}[A-Z]{0,1}\/{0,1}[A-Z]{1,3}[0-9]{1,3}[A-Z]{1,4}\/{0,1}[A-Z]{0,3}[0-9]{0,3}[A-Z]{0,1})\s+/s) {
	$call = $1;
    }

    if ($mode eq "CW") {
	if ($logline =~ m/\s+([1-5][1-9]{2})\s+([1-5][1-9]{2})\s+/s) {
	    $rsts = $1;
	    $rstr = $2;
	}
    }
    if ($mode eq "SSB") {
	if ($logline =~ m/\s+([1-5][1-9]{1})\s+([1-5][1-9]{1})\s+/s) {
	    $rsts = $1;
	    $rstr = $2;
	}
    }

	if (($chopmobilecounty == 1) & ($call =~ m/([AKNW][A-Z]{0,1}[0-9][A-Z]{1,3}\/{0,1}M{0,1})\/[A-Z]{3,4}/s)) {
	    $call = $1;
	}
	if ($chopmobile == 1) {
	    $call =~ s/\/M//gs;
	}

    $adif = sprintf("<call:%d>%s<qso_date:%d>%s<time_on:%d>%s<band:%d>%s<mode:%d>%s<rst_rcvd:%d>%s<rst_sent:%d>%s<eor>",length($call),$call,length($date),$date,length($time),$time,length($band),$band,length($mode),$mode,length($rstr),$rstr,length($rsts),$rsts);
    if ((length($call) > 0) & (length($date) > 0)) {
	print "$adif\n";
    }
}
